﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.8
@EndOfDesignText@


#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public connected As Boolean
	Private client As Socket
	Public server As ServerSocket
	Private astream As AsyncStreams
	Private ThePort As Int 'default = 51070
	Private TheCaller As Object
	Private TheHost As String 
End Sub

Sub Service_Create
	Log("creating service")
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	
	Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
End Sub

public Sub CallNetwork (theData2 As DataToPass)
	Dim TheData As DataToPass
	TheData.Initialize
	TheCaller = theData2.caller 
	ThePort = theData2.port 
	TheHost = theData2.host 
	ConnectToServer
End Sub

Public Sub ConnectToServer
	CloseExistingConnection
	Dim client As Socket
	client.Initialize("client")
	client.Connect(TheHost, ThePort, 10000)
	Wait For Client_Connected (Successful As Boolean)
	If Successful Then
		astream.InitializePrefix(client.InputStream, False, client.OutputStream, "astream")
		UpdateState (True)
	Else
		Log("Failed to connect. Check that B4XIDEViewer is running. " & LastException)
	End If
End Sub

Public Sub Disconnect
	CloseExistingConnection
End Sub

Sub CloseExistingConnection
	If astream.IsInitialized Then astream.Close
	If client.IsInitialized Then client.Close
	UpdateState (False)
End Sub

Sub UpdateState (NewState As Boolean)
	connected = NewState
	Log(IsPaused(TheCaller))
	CallSub(TheCaller, "ShowSetState")
End Sub

Sub AStream_Error
	UpdateState(False)
End Sub

Sub AStream_Terminated
	UpdateState(False)
End Sub

Sub AStream_NewData (Buffer() As Byte)
	CallSub2(TheCaller, "NewData", Buffer)
End Sub

Public Sub SendData (data() As Byte)
	If connected Then astream.Write(data)
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

